/**************************************************************************/
/* GF74 ( QUERY状態テーブル )                                             */
/*                                                                        */
/* Created : 2010/08/05 08:49:52                                          */
/**************************************************************************/
CREATE TABLE GF74 (
   SYSTEM_ID VARCHAR(10)                 NOT NULL                  /* 10  システムID     */
 , ADDRESS   VARCHAR(256)                                          /* 20  アドレス       */
 , PRE_FIX   VARCHAR(10)                 NOT NULL                  /* 30  名前空間       */
 , FILENAME  VARCHAR(30)                                           /* 40  ファイル名     */
 , FILEPATH  VARCHAR(256)                                          /* 50  ファイルパス   */
 , MODIFIED  VARCHAR(14)                                           /* 60  最終更新日     */
 , TAGNAME   VARCHAR(30)                                           /* 70  タグ名称       */
 , CLMS      VARCHAR(500)                                          /* 80  カラム一覧     */
 , TABLEID   VARCHAR(50)                                           /* 90  テーブルID     */
 , DBID      VARCHAR(20)                                           /* 100 データベースID */
 , SQL_TYPE  VARCHAR(20)                                           /* 110 クエリータイプ */
 , JSP_SCOPE VARCHAR(20)                                           /* 120 スコープ       */
 , SQL_TEXT  BLOB                                                  /* 130 検索           */
 , FGOMIT    VARCHAR(1)      DEFAULT '0' NOT NULL                  /* 140 除外フラグ     */
 , UNIQ      BIGINT                      NOT NULL PRIMARY KEY      /* 150 ユニークキー   */
 , FGJ       VARCHAR(1)      DEFAULT '1' NOT NULL                  /* 160 状態フラグ     */
 , DYSET     VARCHAR(14)                                           /* 170 登録日時       */
 , PGSET     VARCHAR(10)                                           /* 180 作成PG         */
 , PGPSET    VARCHAR(10)                                           /* 190 作成親PG       */
 , USRSET    VARCHAR(10)                                           /* 200 作成社員       */
 , DYUPD     VARCHAR(14)                                           /* 210 更新日時       */
 , PGUPD     VARCHAR(10)                                           /* 220 更新PG         */
 , PGPUPD    VARCHAR(10)                                           /* 230 更新親PG       */
 , USRUPD    VARCHAR(10)                                           /* 240 更新者         */
);

CREATE SEQUENCE GF74S00 ;


CREATE TRIGGER GF74T00 FOR GF74
  BEFORE INSERT 
  AS BEGIN 
    NEW.UNIQ = GEN_ID( GF74S00,1 );
  END; 


