/**************************************************************************/
/* GF80 ( DB定義書マスタテーブル )                                        */
/*                                                                        */
/* Created : 2010/08/05 08:49:46                                          */
/**************************************************************************/
CREATE TABLE GF80 (
   SYSTEM_ID    VARCHAR(10)                 NOT NULL                                 /* 10  システムID   */
 , TBLSYU       VARCHAR(1)                  NOT NULL                                 /* 20  テーブル種別 */
 , TABLE_NAME   VARCHAR(50)                 NOT NULL                                 /* 30  テーブル名   */
 , NAME_JA      VARCHAR(200)                                                         /* 40  名称         */
 , SEQNO        INTEGER         DEFAULT 0   NOT NULL                                 /* 50  表示順       */
 , CLM_NAME     VARCHAR(120)                                                         /* 60  項目名(漢字) */
 , CLM          VARCHAR(30)                 NOT NULL                                 /* 70  項目         */
 , CLS_NAME     VARCHAR(10)                 NOT NULL                                 /* 80  DBクラス     */
 , PHY_LENGTH   VARCHAR(10)                                                          /* 90  物理桁数     */
 , USE_LENGTH   VARCHAR(9)      DEFAULT '0' NOT NULL                                 /* 100 使用桁数     */
 , UK           VARCHAR(2)                                                           /* 110 UK           */
 , IXA          VARCHAR(2)                                                           /* 120 IXA          */
 , IXB          VARCHAR(2)                                                           /* 130 IXB          */
 , IXC          VARCHAR(2)                                                           /* 140 IXC          */
 , IXD          VARCHAR(2)                                                           /* 150 IXD          */
 , IXE          VARCHAR(2)                                                           /* 160 IXE          */
 , IXF          VARCHAR(2)                                                           /* 170 IXF          */
 , IXG          VARCHAR(2)                                                           /* 180 IXG          */
 , NOT_NULL     VARCHAR(1)                                                           /* 190 NOT NULL     */
 , C_KEY        VARCHAR(1)                                                           /* 200 C_KEY        */
 , F_KEY        VARCHAR(1)                                                           /* 210 F_KEY        */
 , RENDERER     VARCHAR(10)                                                          /* 220 表示種別     */
 , EDITOR       VARCHAR(10)                                                          /* 230 編集種別     */
 , DBTYPE       VARCHAR(10)                                                          /* 240 文字種別     */
 , DATA_DEFAULT VARCHAR(30)                                                          /* 250 初期値       */
 , KBCLM        VARCHAR(1)                                                           /* 260 カラム区分   */
 , BIKO         TEXT                                                                 /* 270 備考         */
 , CDKH         VARCHAR(1)                                                           /* 280 改廃コード   */
 , COMMENTS     TEXT                                                                 /* 290 コメント     */
 , UNIQ         BIGINT                      NOT NULL PRIMARY KEY AUTO_INCREMENT      /* 300 ユニークキー */
 , FGJ          VARCHAR(1)      DEFAULT '1' NOT NULL                                 /* 310 状態フラグ   */
 , DYSET        VARCHAR(14)                                                          /* 320 登録日時     */
 , PGSET        VARCHAR(10)                                                          /* 330 作成PG       */
 , PGPSET       VARCHAR(10)                                                          /* 340 作成親PG     */
 , USRSET       VARCHAR(10)                                                          /* 350 作成社員     */
 , DYUPD        VARCHAR(14)                                                          /* 360 更新日時     */
 , PGUPD        VARCHAR(10)                                                          /* 370 更新PG       */
 , PGPUPD       VARCHAR(10)                                                          /* 380 更新親PG     */
 , USRUPD       VARCHAR(10)                                                          /* 390 更新者       */
);


